<?php
// $Id: variable.drush.inc,v 1.19 2010/03/25 02:48:17 weitzman Exp $

/**
 * Implementation of hook_drush_help().
 *
 * This function is called whenever a drush user calls
 * 'drush help <name-of-your-command>'
 *
 * @param
 *   A string with the help section (prepend with 'drush:')
 *
 * @return
 *   A string with the help text for your command.
 */
function cfreport_drush_help($section) {
  switch ($section) {
    case 'drush:cforge-report':
      return dt("Be part of a wider network of local currency comunities by sharing a few key pieces of information with Community Forge. We seek your trust and will not abuse this information");
  }
}

/**
 * Implementation of hook_drush_command().
 *
 * In this hook, you specify which commands your
 * drush module makes available, what it does and
 * description.
 *
 * Notice how this structure closely resembles how
 * you define menu hooks.
 *
 * @return
 *   An associative array describing your command(s).
 */
function cfreport_drush_command() {
  $items['cforge-report'] = array(
    'callback' => 'drush_cforge_report',
    'description' => 'show the standard community participation stats',
  );
  return $items;
}

function drush_cforge_report() {
  module_load_include('inc', 'cforge_custom');
  $stats = cforge_get_report();
  unset($stats['logo']);
  foreach ($stats as $stat) {
    $rows[$stat['title']] = strip_tags($stat['value']);
  }
  drush_print_table(drush_key_value_to_array_table($rows));
}